/**
 * A helper for creating a chart based on a table (conf. <https://jackens.github.io/nnn/chartable/>).
 *
 * Options:
 * - `bottom`: bottom padding (for X axis labels)
 * - `gapX`: X axis spacing
 * - `gapY`: Y axis spacing
 * - `headerColumn`: flag indicating that `table` has a header column (with X axis labels)
 * - `headerRow`: flag indicating that `table` has a header row (with data series labels)
 * - `id`: chart id
 * - `left`: left padding (for data series labels)
 * - `maxY`: number of Y axis lines
 * - `right`: right padding (for data series labels)
 * - `singleScale`: flag to force single scale
 * - `table`: `HTMLTableElement` to extract data, data series labels and X axis labels
 * - `title`: chart title
 * - `top`: top padding (for the title)
 * - `xLabels`: X axis labels
 * - `zLabels`: data series labels
 * - `zxY`: chart data
 */
export function chartable({ bottom, gapX, gapY, headerColumn, headerRow, id, left, maxY, right, singleScale, table, title, top, xLabels, zLabels, zxY }?: {
    bottom?: number;
    gapX?: number;
    gapY?: number;
    headerColumn?: boolean;
    headerRow?: boolean;
    id?: string;
    left?: number;
    maxY?: number;
    right?: number;
    singleScale?: boolean;
    table?: HTMLTableElement;
    title?: string;
    top?: number;
    xLabels?: string[];
    zLabels?: string[];
    zxY?: number[][];
}): SVGSVGElement;

export const tests: {};
