/**
 * The type of arguments of the `escapeValues` and `escape` helpers.
 */
export type EscapeMap = Map<any, (value?: any) => string>;

/**
 * A generic helper for escaping `values` by given `escapeMap` (in *TemplateStrings* flavor).
 */
export function escape(escapeMap: EscapeMap, template: TemplateStringsArray, ...values: any[]): string;

/**
 * A generic helper for escaping `values` by given `escapeMap`.
 */
export function escapeValues(escapeMap: EscapeMap, values: any[]): string[];

export namespace tests {
    function escape(): void;
}
