/**
 * A helper that checks if the given argument is of a certain type.
 */
export const is: {
    (type: BigIntConstructor, arg: any): arg is bigint;
    (type: BooleanConstructor, arg: any): arg is boolean;
    (type: NumberConstructor, arg: any): arg is number;
    (type: StringConstructor, arg: any): arg is string;
    (type: SymbolConstructor, arg: any): arg is symbol;
    (type: undefined, arg: any): arg is null | undefined;
    <T extends abstract new (...args: any[]) => any>(type: T, arg: any): arg is InstanceType<T>;
};

export const tests: {
    is: () => void;
    'is: toString.call': () => void;
};
