/**
 * A generic helper for syntax highlighting (see also `nanolightJs`).
 */
export const nanolight = (
  /** @type {RegExp} */ pattern,
  /** @type {((chunk: string, index: number) => import('./h.js').HArgs1)[]} */ highlighters,
  /** @type {string} */ code
) => {
  const /** @type {import('./h.js').HArgs1[]} */ result = []

  code.split(pattern).forEach((chunk, index) => {
    if (chunk != null && chunk !== '') {
      index %= highlighters.length
      result.push(highlighters[index](chunk, index))
    }
  })

  return result
}

export const tests = {}
