/**
 * A helper for choosing the correct singular and plural.
 */
export const plUral = (
  /** @type {string} */ singular,
  /** @type {string} */ plural2,
  /** @type {string} */ plural5,
  /** @type {number} */ value
) => {
  const absValue = Math.abs(value)
  const absValueMod10 = absValue % 10

  return value === 1
    ? singular
    : (absValueMod10 === 2 || absValueMod10 === 3 || absValueMod10 === 4) &&
      absValue !== 12 && absValue !== 13 && absValue !== 14
        ? plural2
        : plural5
}

export const tests = {
  plUral: () => {
    // @ts-ignore
    const auto = plUral.bind(null, 'auto', 'auta', 'aut')

    console.assert(auto(0) === 'aut')
    console.assert(auto(1) === 'auto')
    console.assert(auto(17) === 'aut')
    console.assert(auto(42) === 'auta')

    // @ts-ignore
    const car = plUral.bind(null, 'car', 'cars', 'cars')

    console.assert(car(0) === 'cars')
    console.assert(car(1) === 'car')
    console.assert(car(17) === 'cars')
    console.assert(car(42) === 'cars')
  }
}
